/*
 * QSqlDriver for SQLCipher
 * Copyright 2014  Christian David <christian-david@web.de>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef QSQLCIPHERDRIVERPLUGIN_H
#define QSQLCIPHERDRIVERPLUGIN_H

#include <QtCore/QtPlugin>
#include <QtSql/QSqlDriverPlugin>

#ifdef QT_PLUGIN
#define Q_EXPORT_SQLDRIVER_SQLCIPHER
#else
#define Q_EXPORT_SQLDRIVER_SQLCIPHER Q_SQL_EXPORT
#endif

QT_BEGIN_NAMESPACE

class Q_EXPORT_SQLDRIVER_SQLCIPHER QSqlcipherDriverPlugin : public QSqlDriverPlugin
{
  Q_OBJECT

public:
  virtual QSqlDriver* create(const QString&);
  virtual QStringList keys() const;
};

QT_END_NAMESPACE

#endif // QSQLCIPHERDRIVERPLUGIN_H
